/*
 * Copyright 2019 by Kappich Systemberatung Aachen
 * ALL RIGHTS RESERVED.
 */

package de.bsvrz.dav.daf.accessControl.internal;

/**
 * Steht für eine Aktion, die ein Benutzer durchführen kann, und für die z.B. ExtendedUserInfo überprüfen soll, ob sie erlaubt ist
 *
 * @author Kappich Systemberatung
 * @version $Revision: 0000 $
 */
public enum UserAction {

	RECEIVER("Empfänger"),    // Daten lesen
	SENDER("Sender"),         // Daten schreiben
	SOURCE("Quelle"),         // Daten als Quelle anmelden
	DRAIN("Senke")            // Daten als Senke anmelden
	;
	private final String _text;

	UserAction(final String text) {
		_text = text;
	}

	@Override
	public String toString() {
		return _text;
	}
}
